//Event_Racing

//Changelog v3
//- Fixed race not finishing for races with a single lap
//- Changed both minimum values for startRace from 0 to 1
//- Changed both default values for startRace from 3 to 1
//- Changed maximum value of possible laps from 100 to 300
//- Miscellaneous code bettering
//- Changed arbitrary timeout value from 10 seconds to 1 second
//- Fixed issues with onRaceEnd not being triggered
//- Fixed laps counting in some circumstances where there was no race
//- Fixed reference time not being reset
//- Added a much needed checkpoint system
//- Updated startRace to include a third parameter for checkpoints
//- Added a new input event onRaceStart
//- Updated and fixed use instructions
//- Added a new video to explain all this crap @ http://youtu.be/SK2m9-pqFVA

registerOutputEvent(Minigame,"StartRace","int 1 99 1\tint 1 300 1\tint 0 99 0",1);
registerOutputEvent(Player,"RaceCheckpoint","int 1 99 1");
registerOutputEvent(Player,"IncLap","");
registerOutputEvent(Player,"FinishRace","");
registerOutputEvent(Minigame,"EndRace","",1);
registerInputEvent(FxDTSBrick,"onRaceStart","Self FxDTSBrick\tMinigame Minigame");
registerInputEvent(FxDTSBrick,"onRaceEnd","Self FxDTSBrick\tMinigame Minigame");

function MiniGameSO::StartRace(%minigame,%finishNum,%lapNum,%checkNum,%client)
{
	if(%minigame.raceInProgress)
		return messageClient(%client,'',"\c6You can only have one race per minigame");
	%minigame.raceInProgress = true;
	%minigame.raceDisplayStop = false;
	%minigame.raceNumFinishes = 0;
	%minigame.raceFinishesCap = %finishNum;
	%minigame.raceFinishers = " ";
	%minigame.raceStartTime = getSimTime();
	%minigame.raceLapsCap = %lapNum;
	%minigame.RaceCheckpoints = %checkNum;
	%checkpoints = 1;
	if(%checkNum == 0)
		%checkpoints = "Lap";
	for(%i=0;%i<%minigame.numMembers;%i++)
	{
		%clObj = %minigame.member[%i];
		%clObj.raceLapCount = "Lap 1";
		if(%lapNum == 1)
			%clObj.raceLapCount = "Time";
		%clObj.raceMinLapTime = %minigame.raceStartTime + 1000;
		%clObj.raceDisplayStop = false;
		%clObj.raceCheck = %checkpoints;
		displayTimer(%clObj,%minigame,"0:00.00",0,0);
	}
	%raceStartQueue = trim($Racing::onRaceStartQueue);
	for(%i=0;%i<getWordCount(%raceStartQueue);%i++)
	{
		%brick = getWord(%raceStartQueue,%i);
		if(isObject(%brick) && getMinigameFromObject(%brick) == %minigame)
		{
			$InputTarget_["Self"] = %brick;
			$InputTarget_["MiniGame"] = %minigame;
			%brick.processInputEvent("onRaceStart",%client);
		}
	}
}

function displayTimer(%client,%minigame,%time,%iter)
{
	cancel(%client.raceDisplaySched);
	if(getMinigameFromObject(%client) != %minigame || %client.raceDisplayStop || %minigame.raceDisplayStop)
		return;
	%client.bottomPrint("\c6" @ %client.raceLapCount @ "  -  " @ %time,1);
	%iter++;
	%add = getRandom(1,5);
	%time = addRaceTime(%time,%add);
	if(%iter == 50)
	{
		%time = getRaceTime(%minigame.raceStartTime,getSimTime());
		%iter = 0;
	}
	%client.raceDisplaySched = schedule(%add * 10,0,"displayTimer",%client,%minigame,%time,%iter);
}

function Player::RaceCheckpoint(%obj,%idx)
{
	%client = %obj.client;
	%minigame = getMinigameFromObject(%client);
	if(!isObject(%client) || %minigame == -1 || !%minigame.raceInProgress || %client.raceCheck !$= %idx || %client.raceLapCount $= "Finished")
		return;
	%client.raceCheck++;
	if(%client.raceCheck > %minigame.RaceCheckpoints)
		%client.raceCheck = "Lap";
}

function Player::IncLap(%obj)
{
	%client = %obj.client;
	%minigame = getMinigameFromObject(%client);
	if(!isObject(%client) || %minigame == -1 || !%minigame.raceInProgress || getSimTime() < %client.raceMinLapTime || %client.raceLapCount $= "Finished")
		return;
	if(%client.raceCheck !$= "Lap")
		return;
	else if(%client.raceLapCount $= "Final Lap")
	{
		%client.raceLapCount = "Finished";
		messageClient(%client,'',"\c6 Lap Time: +" @ getRaceTime(%client.raceMinLapTime - 1000,getSimTime()));
		return %obj.finishRace();
	}
	else if(%client.raceLapCount $= "Time")
	{
		%client.raceLapCount = "Finished";
		return %obj.finishRace();
	}
	%newLap = getWord(%client.raceLapCount,1) + 1;
	%client.raceLapCount = "Lap " @ %newLap;
	if(%newLap == getMinigamefromObject(%client).raceLapsCap)
		%client.raceLapCount = "Final Lap";
//	if(%newLap == 2)
//		%client.raceMinLapTime = %minigame.raceStartTime + 1000;
	messageClient(%client,'',"\c6 Lap Time: +" @ getRaceTime(%client.raceMinLapTime - 1000,getSimTime()));
	%client.centerPrint("\c6" @ %client.raceLapCount,3);
	%client.raceMinLapTime = getSimTime() + 1000;
	if(%minigame.RaceCheckpoints == 0)
		%client.raceCheck = "Lap";
	else
		%client.raceCheck = 1;
}

function Player::FinishRace(%obj)
{
	%client = %obj.client;
	%minigame = getMinigameFromObject(%client);
	if(%minigame == -1 || !%minigame.raceInProgress || strStr(%minigame.raceFinishers," " @ %client @ " ") != -1)
		return;
	%time = (getSimTime() - %minigame.raceStartTime) / 1000;
	%minutes = mFloor(%time / 60);
	%seconds = mFloatLength(%time - (%minutes * 60),2);
	if(strLen(%seconds) == 4)
		%seconds = "0" @ %seconds;
	if(%minutes >= 60)
	{
		%hours = mFloor(%minutes / 60) @ ":";
		%minutes = %minutes - (%hours * 60);
	}
	%placement = getPlacing(%minigame.raceNumFinishes);
	%minigame.raceNumFinishes++;
	%minigame.raceFinishers = %minigame.raceFinishers @ %client @ " ";
	%finishTime = %hours @ %minutes @ ":" @ %seconds;
	%placement = getPlacing(%minigame.raceNumFinishes);
	%minigame.messageAll('',"<bitmap:base/client/ui/ci/trophy>" @ %client.name @ "<bitmap:base/client/ui/ci/trophy>\c6 has finished in \c0" @ %placement @ "\c6 place with a time of \c0" @ %finishTime);
	%client.raceDisplayStop = true;
	%client.schedule(500,bottomPrint,"<bitmap:base/client/ui/ci/trophy>\c6You finished in \c0" @ %placement @ "\c6 place, with a time of \c0" @ %finishTime,30);
	%client.play2D(rewardSound);
	%obj.emote(winStarProjectile,1);
	if(%minigame.raceNumFinishes == %minigame.raceFinishesCap)
		%minigame.EndRace();
}

function MinigameSO::EndRace(%minigame,%client)
{
	if(!%minigame.raceInProgress)
	{
		if(%client $= "")
			return;
		return messageClient(%client,'',"\c6There's no race to end!");
	}
	%minigame.raceInProgress = false;
	%minigame.raceDisplayStop = true;
	%minigame.raceFinishers = " ";
	%raceEndQueue = trim($Racing::onRaceEndQueue);
	for(%i=0;%i<getWordCount(%raceEndQueue);%i++)
	{
		%brick = getWord(%raceEndQueue,%i);
		if(isObject(%brick) && getMinigameFromObject(%brick) == %minigame)
		{
			$InputTarget_["Self"] = %brick;
			$InputTarget_["MiniGame"] = %minigame;
			%brick.processInputEvent("onRaceEnd",%client);
		}
	}
}

//Yes, I used z0w0's minigame events as a reference
$Racing::onRaceStartIndex = inputEvent_GetInputEventIdx("onRaceStart");
$Racing::onRaceStartQueue = " ";
$Racing::onRaceEndIndex = inputEvent_GetInputEventIdx("onRaceEnd");
$Racing::onRaceEndQueue = " ";

if(isPackage(RacingEvents))
	deactivatePackage(RacingEvents);
package RacingEvents
{
	function ServerCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4)
	{
		%wb = %client.wrenchbrick;
		if(%input == $Racing::onRaceEndIndex && strPos($Racing::onRaceEndQueue," " @ %wb @ " ") == -1)
			$Racing::onRaceEndQueue = $Racing::onRaceEndQueue @ %wb @ " ";
		if(%input == $Racing::onRaceStartIndex && strPos($Racing::onRaceStartQueue," " @ %wb @ " ") == -1)
			$Racing::onRaceStartQueue = $Racing::onRaceStartQueue @ %wb @ " ";
		return Parent::ServerCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4);
	}
	
	function ServerCmdClearEvents(%client)
	{
		%wb = %client.wrenchbrick;
		%pos = strPos($Racing::onRaceEndQueue," " @ %wb @ " ");
		if(%pos != -1)
		{
			%val = %pos + strLen(%wb) + 1;
			$Racing::onRaceEndQueue = getSubStr($Racing::onRaceEndQueue,0,%pos) @ getSubStr($Racing::onRaceEndQueue,%val,strLen($Racing::onRaceEndQueue) - %val);
		}
		%pos = strPos($Racing::onRaceStartQueue," " @ %wb @ " ");
		if(%pos != -1)
		{
			%val = %pos + strLen(%wb) + 1;
			$Racing::onRaceStartQueue = getSubStr($Racing::onRaceStartQueue,0,%pos) @ getSubStr($Racing::onRaceStartQueue,%val,strLen($Racing::onRaceStartQueue) - %val);
		}
		return Parent::ServerCmdClearEvents(%client);
	}
	
	function FxDtsBrick::onDeath(%brick)
	{
		%pos = strPos($Racing::onRaceEndQueue," " @ %brick @ " ");
		if(%pos != -1)
		{
			%val = %pos + strLen(%brick) + 1;
			$Racing::onRaceEndQueue = getSubStr($Racing::onRaceEndQueue,0,%pos) @ getSubStr($Racing::onRaceEndQueue,%val,strLen($Racing::onRaceEndQueue) - %val);
		}
		%pos = strPos($Racing::onRaceStartQueue," " @ %brick @ " ");
		if(%pos != -1)
		{
			%val = %pos + strLen(%brick) + 1;
			$Racing::onRaceStartQueue = getSubStr($Racing::onRaceStartQueue,0,%pos) @ getSubStr($Racing::onRaceStartQueue,%val,strLen($Racing::onRaceStartQueue) - %val);
		}
		return Parent::onDeath(%brick);
	}
	
	function MinigameSO::Reset(%minigame,%client)
	{
		Parent::Reset(%minigame,%client);
		%minigame.endRace(%minigame);
	}
};
activatePackage(RacingEvents);

function getRaceTime(%start,%end)
{
	%time = (%end - %start) / 1000;
	%minutes = mFloor(%time / 60);
	%seconds = mFloatLength(%time - (%minutes * 60),2);
	if(strLen(%seconds) == 4)
		%seconds = "0" @ %seconds;
	if(%minutes >= 60)
	{
		%hours = mFloor(%minutes / 60) @ ":";
		%minutes = %minutes - (%hours * 60);
	}
	return %hours @ %minutes @ ":" @ %seconds;
}

function addRaceTime(%raceTime,%add)
{
	%len = strLen(%raceTime); //"0:00.00"
	%before = getSubStr(%raceTime,0,%len - 5); //"0:"
	%seconds = getSubStr(%raceTime,%len - 5,5) + (%add / 100);//"00.00"
	if(%seconds >= 60.00)
	{
		%seconds -= 60;
		if(strStr(getSubStr(%raceTime,0,%len - 6),":") == -1)
			%minutes = %before;
		else //"0:00:00.00"
		{
			%minutes = getSubStr(%raceTime,strStr(%raceTime,":") + 1,2);
			%hours = getSubStr(%raceTime,0,1);
		}
		%minutes++;
		if(%minutes >= 60)
		{
			%minutes -= 60;
			%hours++;
		}
		%before = %hours @ %minutes;
	}
	%seconds = mFloatLength(%seconds,2);
	if(strLen(%seconds) == 4)
		%seconds = "0" @ %seconds;
	return %before @ %seconds;
}

function getPlacing(%num)
{
	if(%num == 11 || %num == 12 || %num == 13)
		return %num @ "th";
	%last = getSubStr(%num,strLen(%num) - 1,1);
	if(%last == 1)
		return %num @ "st";
	else if(%last == 2)
		return %num @ "nd";
	else if(%last == 3)
		return %num @ "rd";
	else
		return %num @ "th";
}

